var ytilde ybar y rr infl r ri 
u_infl a u_r infltarg 
ytildestar ybarstar ystar rrstar inflstar rstar ristar  
u_inflstar astar u_rstar infltargstar;

varexo error_infl error_a error_r error_infltarg  
error_inflstar error_astar error_rstar error_infltargstar;

parameters sigma0 beta lambda sigma kappa0 delta kappa phi theta gamma 
rhou_infl rhoa rhor rhou_r
phipi phiy
rhoinfltarg infltargbar
c2 c4 
sigma0star betastar lambdastar sigmastar kappa0star deltastar kappastar phistar thetastar 
rhou_inflstar rhoastar rhorstar rhou_rstar 
phipistar phiystar
rhoinfltargstar infltargstarbar
c2star c4star
std_infl std_a std_r std_infltarg
std_inflstar std_astar std_rstar std_infltargstar;

load parameterfiletemp;
set_param_value('sigma0',sigma0);
set_param_value('beta',beta);
set_param_value('lambda',lambda);
set_param_value('sigma',sigma);
set_param_value('kappa0',kappa0);
set_param_value('delta',delta);
set_param_value('kappa',kappa);
set_param_value('phi',phi);
set_param_value('theta',theta);
set_param_value('gamma',gamma);
set_param_value('rhou_infl',rhou_infl);
set_param_value('rhoa',rhoa);
set_param_value('rhor',rhor);
set_param_value('rhou_r',rhou_r);
set_param_value('phipi',phipi);
set_param_value('phiy',phiy);
set_param_value('rhoinfltarg',rhoinfltarg);
set_param_value('infltargbar',infltargbar);
set_param_value('c2',c2);
set_param_value('c4',c4);
set_param_value('sigma0star',sigma0star);
set_param_value('betastar',betastar);
set_param_value('lambdastar',lambdastar);
set_param_value('sigmastar',sigmastar);
set_param_value('kappa0star',kappa0star);
set_param_value('deltastar',deltastar);
set_param_value('kappastar',kappastar);
set_param_value('phistar',phistar);
set_param_value('thetastar',thetastar);
set_param_value('rhou_inflstar',rhou_inflstar);
set_param_value('rhoastar',rhoastar);
set_param_value('rhorstar',rhorstar);
set_param_value('rhou_rstar',rhou_rstar);
set_param_value('phipistar',phipistar);
set_param_value('phiystar',phiystar);
set_param_value('rhoinfltargstar',rhoinfltargstar);
set_param_value('infltargstarbar',infltargstarbar);
set_param_value('c2star',c2star);
set_param_value('c4star',c4star);
set_param_value('std_infl',std_infl);
set_param_value('std_a',std_a);
set_param_value('std_r',std_r);
set_param_value('std_infltarg',std_infltarg);
set_param_value('std_inflstar',std_inflstar);
set_param_value('std_astar',std_astar);
set_param_value('std_rstar',std_rstar);
set_param_value('std_infltargstar',std_infltargstar);

model (linear);

//home country
ytilde = ytilde(+1)-(1/sigma0)*(r-infl(+1)-rr);
rr = sigma0*(ybar(+1)-ybar)+kappa0*(ystar(+1)-ystar);
ybar = (1/kappa)*((1+phi)*a-kappa0*ystar);
ytilde = y-ybar;
infl = beta*infl(+1)+lambda*ytilde+u_infl;
r = rhor*r(-1)+(1-rhor)*(rr+infltarg+phipi*(infl-infltarg)+phiy*ytilde)+u_r;
ri = r-infl(+1);
u_infl = rhou_infl*u_infl(-1)+error_infl;
a = rhoa*a(-1)+error_a;
infltarg = (1-rhoinfltarg)*infltargbar+rhoinfltarg*infltarg(-1)+error_infltarg;
u_r = rhou_r*u_r(-1)+error_r;
 
//foreign country
ytildestar = ytildestar(+1)-(1/sigma0star)*(rstar-inflstar(+1)-rrstar);
rrstar = sigma0star*(ybarstar(+1)-ybarstar)+kappa0star*(y(+1)-y);
ybarstar = (1/kappastar)*((1+phistar)*astar-kappa0star*y);
ytildestar = ystar-ybarstar;
inflstar = betastar*inflstar(+1)+lambdastar*ytildestar+u_inflstar;
rstar = rhorstar*rstar(-1)+(1-rhorstar)*(rrstar+infltargstar+phipistar*(inflstar-infltargstar)+phiystar*ytildestar)+u_rstar;
ristar = rstar-inflstar(+1);
u_inflstar = rhou_inflstar*u_inflstar(-1)+error_inflstar;
astar = rhoastar*astar(-1)+error_astar;
infltargstar = (1-rhoinfltargstar)*infltargstarbar+rhoinfltargstar*infltargstar(-1)+error_infltargstar;
u_rstar = rhou_rstar*u_rstar(-1)+error_rstar;

end;

initval;
ytilde = 0; 
ybar = 0;
y = 0; 
rr = 0;
infl = 0; 
r = 0;  
infltarg = infltargbar;  
ri = r-infl; 
u_infl = 0; 
a = 0; 
u_r = 0;  
ytildestar = 0; 
ybarstar = 0; 
ystar = 0; 
rrstar = 0;
inflstar = 0; 
rstar = 0; 
infltargstar = infltargstarbar; 
ristar = rstar-inflstar;
u_inflstar = 0; 
astar = 0; 
u_rstar = 0; 
end;

steady;

shocks;
var error_infl = std_infl^2;
var error_a  = std_a^2;
var error_r = std_r^2;
var error_infltarg = std_infltarg^2;
var error_inflstar = std_inflstar^2;
var error_astar = std_astar^2;
var error_rstar = std_rstar^2;
var error_infltargstar = std_infltargstar^2;
end;

//stoch_simul(irf=20);
//stoch_simul(nograph);

//varobs r rstar;
//varobs infl r inflstar rstar;
varobs infl r infltarg inflstar rstar infltargstar;
//varobs rr infl r rrstar inflstar rstar;
//varobs rr infl r infltarg rrstar inflstar rstar infltargstar;
//varobs ytilde rr infl r ytildestar rrstar inflstar rstar;
//stoch_simul(partial_information,irf=20) y ystar infl inflstar r rstar;
stoch_simul(partial_information,nograph,nomoments) y ystar infl inflstar r rstar;